package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.query.QueryEngine;
import de.uka.ipd.consensus.foundation.schema.User;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class HomeAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );			
		}
		
		User user = this.getUser( request );
		
		QueryEngine qe = this.getOntologyManager().getQueryEngine();
		
		request.setAttribute( Constants.REQUEST_ATTR_TOPICCOUNT, new Integer(qe.getTopicCount( user )) );
		request.setAttribute( Constants.REQUEST_ATTR_ASSOCIATIONCOUNT, new Integer(qe.getAssociationCount( user )) );

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
